(*

Copyright (C) 2010 FANET Théo

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*)

open Playlist

let _ = GMain.init ()

module App =
  struct
    let name = "NoID"
    let icon = GdkPixbuf.from_file "images/noid.png"
    let version = "v0.1.2"
    let title = name ^ " " ^ version
    let auth = 
"fanet-_t (Fanet Théo)
daboud_j (Daboudet Jérémy)
hebles_f (Hebles Fabien)
chardo_m (Chardon Mika)\n"
  end

let _ = Printf.printf "======== %s ========\nVersion : %s\nAuthors:\n%s======================\n" 
  App.name App.version App.auth
                       
let r = ref 250.0
let v = ref 0.0
let b = ref 0.0

let r2 = ref 0.0
let v2 = ref 250.0
let b2 = ref 0.0

let window = GWindow.window
  ~title:App.title
  ~icon:App.icon
  ~height:600
  ~width:800 
  ~resizable: false
  ~position: `CENTER ()

let splash = GWindow.window
  ~type_hint: `SPLASHSCREEN
  ~position: `CENTER ()

let image2 = GMisc.image
  ~file: "images/image.gif"
  ~packing: splash#add ()

let box = GPack.vbox
  ~packing: window#add ()

(* fenetre principal *)
  (* Visualisateur  *)
let draw = GMisc.drawing_area
  ~height: 50
  ~width: 800
  ~packing: box#add ()

let pixmap = ref (GDraw.pixmap
  ~height:50
  ~width:800 ())

let hbox = GPack.hbox
  ~packing:box#add ()

let vboxSound = GPack.vbox
  ~width:300
  ~height:100
  ~border_width:10
  ~packing:hbox#add ()

  (* box soun 1 *)

let name = GMisc.label
  ~text: "music 1 name"
  ~packing: vboxSound#add ()

let hboxSound = GPack.hbox
  ~width:100
  ~packing:vboxSound#add ()

let progBox = GPack.hbox
  ~height: 10
  ~packing:vboxSound#add ()

let progress1 = GRange.progress_bar
  ~packing: progBox#add ()

let vboxSoundOpt = GPack.hbox
  ~height:80
  ~packing:vboxSound#add ()

let hboxMiddle = GPack.hbox
  ~width:200
  ~packing:hbox#add ()

let vboxSound2 = GPack.vbox
  ~width:300
  ~height:200
  ~border_width:10
  ~packing:hbox#add ()

let play_button = GBin.event_box
  ~packing:hboxSound#add ()

let pause_button = GBin.event_box
  ~packing:hboxSound#add ()

let stop_button = GBin.event_box
  ~packing:hboxSound#add ()

let sound_down = GMisc.image
  ~file: "images/sound_down.png"
  ~packing: hboxSound#add ()

let adj = GData.adjustment
  ~value:130.0
  ~lower:0.0
  ~upper:255.0
  ~step_incr:1.0
  ~page_incr:10.0
  ~page_size:0.0 ()

let graveAdj = GData.adjustment
  ~value:130.0
  ~lower:0.0
  ~upper:255.0
  ~step_incr:1.0
  ~page_incr:10.0
  ~page_size:0.0 ()

let middleAdj = GData.adjustment
  ~value:130.0
  ~lower:0.0
  ~upper:255.0
  ~step_incr:1.0
  ~page_incr:10.0
  ~page_size:0.0 ()

let aiguAdj = GData.adjustment
  ~value:130.0
  ~lower:0.0
  ~upper:255.0
  ~step_incr:1.0
  ~page_incr:10.0
  ~page_size:0.0 ()

let soundBox = GPack.hbox
  ~width:100
  ~packing: hboxSound#add ()

let sound_controle = GRange.scale `HORIZONTAL
  ~adjustment:adj
  ~packing:soundBox#add ()

let sound_up = GMisc.image
  ~file: "images/sound_up.png"
  ~packing: hboxSound#add ()

let grave_controle = GRange.scale `VERTICAL
  ~adjustment:graveAdj
  ~packing:vboxSoundOpt#add ()

let middle_controle = GRange.scale `VERTICAL
  ~adjustment:middleAdj
  ~packing:vboxSoundOpt#add ()

let aigu_controle = GRange.scale `VERTICAL
  ~adjustment:aiguAdj
  ~packing:vboxSoundOpt#add ()

let _ = 
  sound_controle#set_draw_value false;
  grave_controle#set_inverted true;
  aigu_controle#set_inverted true;
  middle_controle#set_inverted true

let iconePlay = GMisc.image
  ~file: "images/play.png"
  ~packing: play_button#add ()

let iconePause = GMisc.image
  ~file: "images/pause.png"
  ~packing: pause_button#add ()

let iconeStop = GMisc.image
  ~file: "images/stop.png"
  ~packing: stop_button#add ()

let _ =
  play_button#event#add [`BUTTON_PRESS];
  pause_button#event#add [`BUTTON_PRESS];
  stop_button#event#add [`BUTTON_PRESS]

  (* box soun 2 *)

let name2 = GMisc.label
  ~text: "music 2 name"
  ~packing: vboxSound2#add ()

let hboxSound2 = GPack.hbox
  ~width:100
  ~packing:vboxSound2#add ()

let progBox2 = GPack.hbox
  ~height: 10
  ~packing:vboxSound2#add ()

let progress2 = GRange.progress_bar
  ~packing: progBox2#add ()

let vboxSoundOpt2 = GPack.hbox
  ~height:80
  ~packing:vboxSound2#add ()

let play_button2 = GBin.event_box
  ~packing:hboxSound2#add ()

let pause_button2 = GBin.event_box
  ~packing:hboxSound2#add ()

let stop_button2 = GBin.event_box
  ~packing:hboxSound2#add ()

let sound_down2 = GMisc.image
  ~file: "images/sound_down.png"
  ~packing: hboxSound2#add ()

let adj2 = GData.adjustment
  ~value:130.0
  ~lower:0.0
  ~upper:255.0
  ~step_incr:1.0
  ~page_incr:10.0
  ~page_size:0.0 ()

let graveAdj2 = GData.adjustment
  ~value:130.0
  ~lower:0.0
  ~upper:255.0
  ~step_incr:1.0
  ~page_incr:10.0
  ~page_size:0.0 ()

let middleAdj2 = GData.adjustment
  ~value:130.0
  ~lower:0.0
  ~upper:255.0
  ~step_incr:1.0
  ~page_incr:10.0
  ~page_size:0.0 ()

let aiguAdj2 = GData.adjustment
  ~value:130.0
  ~lower:0.0
  ~upper:255.0
  ~step_incr:1.0
  ~page_incr:10.0
  ~page_size:0.0 ()

let soundBox2 = GPack.hbox
  ~width:100
  ~packing: hboxSound2#add ()

let sound_controle2 = GRange.scale `HORIZONTAL
  ~adjustment:adj2
  ~packing:soundBox2#add ()

let sound_up2 = GMisc.image
  ~file: "images/sound_up.png"
  ~packing: hboxSound2#add ()

let grave_controle2 = GRange.scale `VERTICAL
  ~adjustment:graveAdj2
  ~packing:vboxSoundOpt2#add ()

let middle_controle2 = GRange.scale `VERTICAL
  ~adjustment:middleAdj2
  ~packing:vboxSoundOpt2#add ()

let aigu_controle2 = GRange.scale `VERTICAL
  ~adjustment:aiguAdj2
  ~packing:vboxSoundOpt2#add ()

let _ = 
  sound_controle2#set_draw_value false;
  grave_controle2#set_inverted true;
  aigu_controle2#set_inverted true;
  middle_controle2#set_inverted true

let iconePlay2 = GMisc.image
  ~file: "images/play.png"
  ~packing: play_button2#add ()

let iconePause2 = GMisc.image
  ~file: "images/pause.png"
  ~packing: pause_button2#add ()

let iconeStop2 = GMisc.image
  ~file: "images/stop.png"
  ~packing: stop_button2#add ()

let _ =
  play_button2#event#add [`BUTTON_PRESS];
  pause_button2#event#add [`BUTTON_PRESS];
  stop_button2#event#add [`BUTTON_PRESS]

let emptyBox = GPack.hbox
  ~height:100
  ~packing: box#add ()

let tabb = GPack.notebook
  ~height: 300
  ~tab_pos:`TOP
  ~packing: box#add ()

let labelPlaylist = GMisc.label
  ~text:"Playlist" ()

let labelEffect = GMisc.label
  ~text:"Effets" ()

let labelOption = GMisc.label
  ~text:"Options" ()

(* effect panel *)

let effectBox = GPack.table
  ~rows:3
  ~columns:4 ()

let effect1 = GButton.button
  ~label:"effet 1" ()

let effect2 = GButton.button
  ~label:"effet 2" ()

let effect3 = GButton.button
  ~label:"effet 3" ()

let effect4 = GButton.button
  ~label:"effet 4" ()

let effect5 = GButton.button
  ~label:"effet 5" ()

let effect6 = GButton.button
  ~label:"effet 6" ()

let effect7 = GButton.button
  ~label:"effet 7" ()

let effect8 = GButton.button
  ~label:"effet 8" ()

let effect9 = GButton.button
  ~label:"effet 9" ()

let effect10 = GButton.button
  ~label:"effet 10" ()

let effect11 = GButton.button
  ~label:"effet 11" ()

let effect12 = GButton.button
  ~label:"effet 12" ()

let _ = 
  effectBox#attach ~left:1 ~top:0 effect1#coerce;
  effectBox#attach ~left:2 ~top:0 effect2#coerce;
  effectBox#attach ~left:3 ~top:0 effect3#coerce;
  effectBox#attach ~left:4 ~top:0 effect4#coerce;
  effectBox#attach ~left:1 ~top:1 effect5#coerce;
  effectBox#attach ~left:2 ~top:1 effect6#coerce;
  effectBox#attach ~left:3 ~top:1 effect7#coerce;
  effectBox#attach ~left:4 ~top:1 effect8#coerce;
  effectBox#attach ~left:1 ~top:2 effect9#coerce;
  effectBox#attach ~left:2 ~top:2 effect10#coerce;
  effectBox#attach ~left:3 ~top:2 effect11#coerce;
  effectBox#attach ~left:4 ~top:2 effect12#coerce

let boxColor = GPack.vbox ()

let couleur1Label = GMisc.label
  ~text:"Couleur de dépar"
  ~packing:boxColor#add ()

let redBox = GPack.hbox 
  ~packing: boxColor#add ()

let greenBox = GPack.hbox
  ~packing: boxColor#add ()

let blueBox = GPack.hbox 
  ~packing: boxColor#add ()

let redLabel = GMisc.label
  ~text: "Rouge :"
  ~packing: redBox#add ()

let redEdit = GEdit.entry
  ~text: (string_of_float !r)
  ~width:200
  ~packing: redBox#add ()

let greenLabel = GMisc.label
  ~text: "Vert  :"
  ~packing: greenBox#add ()

let greenEdit = GEdit.entry
  ~text: (string_of_float !v)
  ~width:200
  ~packing: greenBox#add ()

let blueLabel = GMisc.label
  ~text: "Bleu  :"
  ~packing: blueBox#add ()

let blueEdit = GEdit.entry
  ~text: (string_of_float !b)
  ~width:200
  ~packing: blueBox#add ()

let couleur2Label = GMisc.label
  ~text:"Couleur d'arrivée"
  ~packing: boxColor#add ()

let redBox2 = GPack.hbox 
  ~packing: boxColor#add ()

let greenBox2 = GPack.hbox
  ~packing: boxColor#add ()

let blueBox2 = GPack.hbox 
  ~packing: boxColor#add ()

let redLabel2 = GMisc.label
  ~text: "Rouge :"
  ~packing: redBox2#add ()

let redEdit2 = GEdit.entry
  ~text: (string_of_float !r2)
  ~width:200
  ~packing: redBox2#add ()

let greenLabel2 = GMisc.label
  ~text: "Vert :"
  ~packing: greenBox2#add ()

let greenEdit2 = GEdit.entry
  ~text: (string_of_float !v2)
  ~width:200
  ~packing: greenBox2#add ()

let blueLabel2 = GMisc.label
  ~text: "Bleu :"
  ~packing: blueBox2#add ()

let blueEdit2 = GEdit.entry
  ~text: (string_of_float !b2)
  ~width:200
  ~packing: blueBox2#add ()

let applyButton = GButton.button
  ~label:"appliquer"
  ~packing:boxColor#add ()

let playList = GPack.hbox
  ~spacing:10 ()

let _ = 
  tabb#append_page ~tab_label: labelPlaylist#coerce playList#coerce;
  tabb#append_page ~tab_label: labelEffect#coerce effectBox#coerce;
  tabb#append_page ~tab_label: labelOption#coerce boxColor#coerce

(* Le widget list_view *)
let scroll1 = GBin.scrolled_window
  ~hpolicy:`ALWAYS
  ~vpolicy:`ALWAYS
  ~packing:playList#add ()

let scroll2 = GBin.scrolled_window
  ~hpolicy:`ALWAYS
  ~vpolicy:`ALWAYS
  ~packing:playList#add ()

let updateSound1 s =
  Son.loadSound1 ("musiques/"^s);
  name#set_text (Son.getName1 ())

let updateSound2 s =
  Son.loadSound2 ("musiques/"^s);
  name2#set_text (Son.getName2 ())

let view1 = 
  let view = GTree.view
    ~model:Data1.store
    ~rules_hint:true
    ~packing: scroll1#add () in
  view#append_column View1.col1;
  let sel = view#selection in
    sel#connect#changed (fun _ -> updateSound1 (get_text1 sel));
  view

let view2 = 
  let view = GTree.view
    ~model:Data2.store
    ~rules_hint:true
    ~packing: scroll2#add () in
  view#append_column View2.col1;
  let sel = view#selection in
    sel#connect#changed (fun _ -> updateSound2 (get_text2 sel));
  view

let makeList () = 
  let files = Sys.readdir "musiques/" in
    Array.iter Playlist.addItem2 files;
    Array.iter Playlist.addItem1 files
