(*

Copyright (C) 2010 FANET Théo

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*)

let _ =
  GMain.init ();
  Son.initSound ();
  Gui.name#set_text (Son.getName1());
  Gui.name2#set_text (Son.getName2());
  Gui.makeList ()    

let hms_from_ms ms =
  let sp = (ms/1000) in
  let s = sp mod 60 in
  let m = (sp/60) mod 60 in
  let h = (sp/3600) in
    (string_of_int h)^":"^(string_of_int m)^":"^(string_of_int s)

let updateProgress = fun _ -> 
  Gui.progress1#set_fraction (float_of_int(Son.getPos1())/.float_of_int(Son.getLength1()));
  Gui.progress1#set_text ((hms_from_ms (Son.getPos1 ()))^"/"^(hms_from_ms (Son.getLength1 ())));
  true

let updateProgress2 = fun _ -> 
  Gui.progress2#set_fraction (float_of_int(Son.getPos2())/.float_of_int(Son.getLength2()));
  Gui.progress2#set_text ((hms_from_ms (Son.getPos2 ()))^"/"^(hms_from_ms (Son.getLength2 ())));
  true

let main () =
  begin

    Gui.window#connect#destroy ~callback:GMain.quit;

    Gui.applyButton#connect#clicked (fun _ -> Gui.r := float_of_string (Gui.redEdit#text);
				              Gui.v := float_of_string (Gui.greenEdit#text);
					      Gui.b := float_of_string (Gui.blueEdit#text);
					      Gui.r2 := float_of_string (Gui.redEdit2#text);
				              Gui.v2 := float_of_string (Gui.greenEdit2#text);
					      Gui.b2 := float_of_string (Gui.blueEdit2#text);
				              Visu.synchronize());



    Gui.play_button#event#connect#button_press (fun _ -> Son.playSound1 ();
						         Gui.name#set_text(Son.getName1());
						         Visu.synchronize();
							 GMain.Timeout.add ~ms:25 ~callback:updateProgress;true);

    Gui.pause_button#event#connect#button_press (fun _ -> Son.setPause1();
						         true);

    Gui.stop_button#event#connect#button_press (fun _ -> Son.stopSound1();
						         Gui.progress1#set_fraction 0.0;
							 Son.setPos1 0;
						         true);
    
    Gui.play_button2#event#connect#button_press (fun _ -> Son.playSound2 ();
						         Gui.name2#set_text(Son.getName2());
						         Visu.synchronize();
							 GMain.Timeout.add ~ms:25 ~callback:updateProgress2;true);

    Gui.pause_button2#event#connect#button_press (fun _ -> Son.setPause2();
						         true);

    Gui.stop_button2#event#connect#button_press (fun _ -> Son.stopSound2();
						         Gui.progress2#set_fraction 0.0;
							 Son.setPos2 0;
						         true);

    (* Gui.color_button#event#connect#button_press (fun _ -> Gui.colorWindow#show (); true);

    Gui.boutonApply#connect#clicked (fun _ -> Gui.colorWindow#misc#hide ();
				              Gui.r := float_of_string (Gui.redEdit#text);
				              Gui.v := float_of_string (Gui.greenEdit#text);
					      Gui.b := float_of_string (Gui.blueEdit#text);
					      Gui.r2 := float_of_string (Gui.redEdit2#text);
				              Gui.v2 := float_of_string (Gui.greenEdit2#text);
					      Gui.b2 := float_of_string (Gui.blueEdit2#text);
				              );
    *)    

    Gui.adj#connect#value_changed ~callback:(fun _ -> Son.setVolume1(Gui.sound_controle#get_oid); ());

        
    Gui.draw#event#connect#expose (Visu.expose Gui.draw Gui.pixmap);
    Gui.splash#show ();
    GMain.Timeout.add ~ms:1000 ~callback:(fun _ -> Gui.splash#misc#hide (); 
					           Gui.window#show ();
						   true);
    Visu.draw_filled_rect 0 0 5 5;
    Visu.synchronize();
    GMain.main (); 

  end

let _ = main ();Son.closeSound ()
