(*

Copyright (C) 2010 FANET Théo

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*)


module Data1 =
  struct
    let cols = new GTree.column_list        (* Les données *)
    let icon = cols#add GtkStock.conv       (* Une icône *)
    let text = cols#add Gobject.Data.string (* Le texte associé *)
    let store = GTree.list_store cols       (* La vue en liste *)
  end

(* La vue. *)
module View1 =
  struct
    let icon = GTree.cell_renderer_pixbuf []
    let text = GTree.cell_renderer_text [`XPAD 5]
    let create_view_column title cell data =
      let vcol = GTree.view_column ~title () in
      vcol#pack ~expand:false icon;
      vcol#add_attribute icon "stock_id" Data1.icon;
      vcol#pack text;
      vcol#add_attribute text "text" Data1.text;
      vcol
    let col1 = create_view_column "Musiques Player 1" text Data1.text
  end

(* Récupère le texte associé à la ligne sélectionnée.
 * On récupère la liste des lignes sélectionnées.
 * En pratique il n'y a qu'une seule ligne.
 * On convertit le chemin (path) en ligne (iter).
 * On va chercher les données associées pour la colonne Data.text. *)

let get_text1 (sel : GTree.selection) =
  match sel#get_selected_rows with
  | [] -> ""
  | path :: _ -> let iter = Data1.store#get_iter path in
      Data1.store#get ~row:iter ~column:Data1.text 

let addItem1 text = 
   let row = Data1.store#append () in
      Data1.store#set ~row ~column:Data1.text text

module Data2 =
  struct
    let cols = new GTree.column_list        (* Les données *)
    let icon = cols#add GtkStock.conv       (* Une icône *)
    let text = cols#add Gobject.Data.string (* Le texte associé *)
    let store = GTree.list_store cols       (* La vue en liste *)
  end

(* La vue. *)
module View2 =
  struct
    let icon = GTree.cell_renderer_pixbuf []
    let text = GTree.cell_renderer_text [`XPAD 5]
    let create_view_column title cell data =
      let vcol = GTree.view_column ~title () in
      vcol#pack ~expand:false icon;
      vcol#add_attribute icon "stock_id" Data2.icon;
      vcol#pack text;
      vcol#add_attribute text "text" Data2.text;
      vcol
    let col1 = create_view_column "Musiques Player 2" text Data2.text
  end

(* Récupère le texte associé à la ligne sélectionnée.
 * On récupère la liste des lignes sélectionnées.
 * En pratique il n'y a qu'une seule ligne.
 * On convertit le chemin (path) en ligne (iter).
 * On va chercher les données associées pour la colonne Data.text. *)

let get_text2 (sel : GTree.selection) =
  match sel#get_selected_rows with
  | [] -> ""
  | path :: _ -> let iter = Data2.store#get_iter path in
      Data2.store#get ~row:iter ~column:Data2.text 

let addItem2 text = 
   let row = Data2.store#append () in
      Data2.store#set ~row ~column:Data2.text text
