

 //Copyright (C) 2010 FANET Théo

 //This program is free software; you can redistribute it and/or modify
 //it under the terms of the GNU General Public License as published by
 //the Free Software Foundation; either version 2 of the License, or
 //(at your option) any later version.

 //This program is distributed in the hope that it will be useful,
 //but WITHOUT ANY WARRANTY; without even the implied warranty of
 //MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 //GNU General Public License for more details.

 //You should have received a copy of the GNU General Public License along
 //with this program; if not, write to the Free Software Foundation, Inc.,
 //51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 //

#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <caml/alloc.h>
#include "header/fmod.h"
#include "header/wincompat.h"
#include <stdio.h>

FSOUND_STREAM *musique1;
FSOUND_STREAM *musique2;

CAMLprim
value caml_initSound(value unit) {
  CAMLparam1(unit);

  FSOUND_SetOutput(FSOUND_OUTPUT_ALSA);
  FSOUND_Init(44100, 32, 0);
  FSOUND_SetVolume(1, 130);
  FSOUND_SetVolume(2, 130);
  //musique1 = FSOUND_Stream_Open("musiques/test.mp3", FSOUND_LOOP_NORMAL, 0, 0);
  //musique2 = FSOUND_Stream_Open("musiques/test2.mp3", FSOUND_LOOP_NORMAL, 0, 0); 
  musique1 = NULL;
  musique1 = NULL;
  
  FSOUND_DSP_SetActive(FSOUND_DSP_GetFFTUnit(), 1);
  
    
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_closeSound(value unit) {
  CAMLparam1(unit);

  FSOUND_Stream_Close(musique1);
  FSOUND_Stream_Close(musique2); 
  FSOUND_Close();
  
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_loadSound1(value s) {
  CAMLparam1(s);
  
  if(musique1 != NULL)
    FSOUND_Stream_Stop(musique1);
  
  musique1 = FSOUND_Stream_Open(String_val(s), FSOUND_LOOP_NORMAL, 0, 0);
  
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_loadSound2(value s) {
  CAMLparam1(s);
  
  if(musique2 != NULL)
    FSOUND_Stream_Stop(musique2);
  
  musique2 = FSOUND_Stream_Open(String_val(s), FSOUND_LOOP_NORMAL, 0, 0);
  
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_playSound1(value unit) {
  CAMLparam1(unit);

  if(musique1 != NULL)
     FSOUND_Stream_Play(1, musique1);
  
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_playSound2(value unit) {
  CAMLparam1(unit);
  
  if(musique2 != NULL)
    FSOUND_Stream_Play(2, musique2);
  
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_stopSound1(value unit) {
  CAMLparam1(unit);

  if(musique1 != NULL)
    FSOUND_Stream_Stop(musique1);
  
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_stopSound2(value unit) {
  CAMLparam1(unit);
  
  if(musique2 != NULL)
    FSOUND_Stream_Stop(musique2);
  
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_setPause1(value unit) {
  CAMLparam1(unit);
  
  if(musique1 != NULL)
    {

      if (FSOUND_GetPaused(1))
	FSOUND_SetPaused(1, FALSE);
      else
	FSOUND_SetPaused(1, TRUE);
    }
  
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_setPause2(value unit) {
  CAMLparam1(unit);
  
  if(musique2 != NULL)
    {
      if (FSOUND_GetPaused(2))
	FSOUND_SetPaused(2, FALSE);
      else
	FSOUND_SetPaused(2, TRUE);
    }
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_getName1(value unit) {
  CAMLparam1(unit);
  if(musique1 != NULL)
    CAMLreturn(caml_copy_string(FSOUND_Sample_GetName(FSOUND_Stream_GetSample(musique1))));
  else
    CAMLreturn(caml_copy_string(""));
}

CAMLprim
value caml_getName2(value unit) {
  CAMLparam1(unit);
  if(musique2 != NULL)
    CAMLreturn(caml_copy_string(FSOUND_Sample_GetName(FSOUND_Stream_GetSample(musique2))));
  else
    CAMLreturn(caml_copy_string(""));
}

CAMLprim
value caml_getLength1(value unit) {
  CAMLparam1(unit);
  int res = 0;
  if(musique1 != NULL)
    res = FSOUND_Stream_GetLengthMs(musique1);
  CAMLreturn(Val_int(res));
}

CAMLprim
value caml_getLength2(value unit) {
  CAMLparam1(unit);
  int res = 0;
  if(musique2 != NULL)  
    res = FSOUND_Stream_GetLengthMs(musique2);
  CAMLreturn(Val_int(res));
}

CAMLprim
value caml_setVolume1(value i) {
  CAMLparam1(i);
  FSOUND_SetVolume(1, Int_val(i));
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_setVolume2(value i) {
  CAMLparam1(i);
  FSOUND_SetVolume(2, Int_val(i));
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_setPos1(value i) {
  CAMLparam1(i);
  if(musique1 != NULL)
    FSOUND_Stream_SetTime(musique1, Int_val(i));
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_setPos2(value i) {
  CAMLparam1(i);
  if(musique2 != NULL)
    FSOUND_Stream_SetTime(musique2, Int_val(i));
  CAMLreturn(Val_unit);
}

CAMLprim
value caml_getPos1(value unit) {
  CAMLparam1(unit);
  if(musique1 != NULL)
    CAMLreturn(Val_int(FSOUND_Stream_GetTime(musique1)));
  else
    CAMLreturn(Val_int(0));
}

CAMLprim
value caml_getPos2(value unit) {
  CAMLparam1(unit);
  if(musique2 != NULL)
    CAMLreturn(Val_int(FSOUND_Stream_GetTime(musique2)));
  else
    CAMLreturn(Val_int(0));
}

CAMLprim
value caml_getSpectre(value i) {
  CAMLparam1(i);
  
  int c = Int_val(i);
  float *spectre = NULL;
  spectre = FSOUND_DSP_GetSpectrum();
  double res = spectre[c]*1000.0;
  CAMLreturn(caml_copy_double(res));
}
