(*

Copyright (C) 2010 FANET Théo

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*)


external getSpectre : int -> float = "caml_getSpectre"

let _ = GMain.init ()

let synchronize =
  let rect = Some (
    Gdk.Rectangle.create
      ~x:0
      ~y:0
      ~width:800
      ~height:100
  ) in fun () -> Gui.draw#misc#draw rect

let draw_filled_rect ?(backing = !Gui.pixmap) x y width height =
  backing#rectangle ~x:x ~y:y ~width:800 ~height:100 ~filled:true ()

let color r g b = 
  Printf.sprintf "#%02X%02X%02X" (r) (g) (b)

let getCol c c2 i =
  c +. ((float_of_int i) /. 512.0)*.(c2 -. c)

let expose (drawing_area:GMisc.drawing_area) (backing:GDraw.pixmap ref) ev =
  let area = GdkEvent.Expose.area ev in
  let x = Gdk.Rectangle.x area in
  let y = Gdk.Rectangle.y area in
  let width = Gdk.Rectangle.width area in
  let height = Gdk.Rectangle.width area in
  let drawing =
    drawing_area#misc#realize ();
    new GDraw.drawable (drawing_area#misc#window)
  in
    drawing#put_pixmap ~x ~y ~xsrc:x ~ysrc:y ~width ~height !backing#pixmap;
    Random.init 512;
    for i=0 to 512 do
      drawing#set_foreground (`NAME (color (int_of_float (getCol !Gui.r !Gui.r2 i)) (int_of_float (getCol !Gui.v !Gui.v2 i)) (int_of_float (getCol !Gui.b !Gui.b2 i))));
      let h = int_of_float (getSpectre i) in
	drawing#rectangle ~x:(i+144) ~y:(100-h) ~width:1 ~height:h ~filled:true ()
    done;
    synchronize ();
    false
